//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "chat.h"
#include <string.h>
#include <stdio.h>

#include <sys/socket.h> //consts and procedures
#include <arpa/inet.h>  //for sockadd_in !!!
#define LinkListConflict
#include <unistd.h>     //for close()
#include <curses.h>

char* GetName();                   //Gets user's name

int Connect() {
  //Get essential data
  char ipaddr[32];
  Room << "Enter the server's IP address: ";
  Room.scanf(" %31[^\n]", ipaddr);
  in_addr ServIpAddr;
  if (!inet_aton(ipaddr, &ServIpAddr)) {
    Room << "Invalid address!\n";
    return ERROR;
  }
  char* myname = GetName();

  Room << "Connecting to server at " << inet_ntoa(ServIpAddr) << '\n';

  if ((server = socket(AF_INET, SOCK_STREAM, 0)) == ERROR)
    return ERROR;

  servaddr.sin_family = AF_INET;
  servaddr.sin_port = htons(CPORT);
  servaddr.sin_addr = ServIpAddr;
  bzero(&(servaddr.sin_zero), 8);

  if (connect(server, (struct sockaddr *)&servaddr, sizeof(sockaddr)) == ERROR) {
    close(server);
    return ERROR;
  }
  Room << "Connected...\n";

  Room << "Communicating with server\n";
  int newstrlen =
    1 +              //version number
    strlen(myname) + //length of our name
    1;               //NULL character  

  char* packet = new char[newstrlen];
  sprintf(packet, "%c%s", VERSION, myname);

  SendMessage(packet);

  delete[] packet;
  delete[] myname;

  Room << "Checking version\n";
  uchar ver = 0;
  gin += recv(server, &ver, sizeof(uchar), 0);
  if (ver == GOODVER) {
    Room << "  Version " << int(VERSION) << " verified.\n";
  } else {
    Room << "  Version " << int(VERSION) << " is not same as server.  Terminating...\n";
    close(server);
    return ERROR;
  }

  Room << "Recieving room data\n";
  int NumClis = 0;
  gin += recv(server, &NumClis, sizeof(int), 0);
  for (int c=0; c<NumClis; c++) {
    int NameLen = 0;
    gin += recv(server, &NameLen, sizeof(int), 0);
    Clidata* NewUser = new Clidata;
    NewUser->name = new char[NameLen];
    gin += recv(server, NewUser->name, NameLen, 0);
    Clients._MoveData(NewUser);
  }

  //Respond to server's ping
  char temp;
  gin += recv(server, &temp, sizeof(temp), 0);
  gout += send(server, &temp, sizeof(temp), 0);
  int  pingtime;
  gin += recv(server, &pingtime, sizeof(pingtime), 0);
  Room << "Server reports a " << pingtime << "ms ping time\n";

  //Setup connections on UDP broadcasting port
  Room << "Moving to UDP broadcast port\n";
  close(server);    //Close TCP/IP handshake port
  if ((server = socket(AF_INET, SOCK_DGRAM, 0)) == ERROR)
    return ERROR;
  Room << "Created Socket\n";
  servaddr.sin_port = htons(BPORT);//Switch to broadcast port
  if (connect(server, (struct sockaddr *)&servaddr, sizeof(sockaddr)) == ERROR) {
    close(server);
    return ERROR;
  }
  Room << "Connected Socket\n";

  buf[0] = NEW;     //Create new packet to let server trace us
  buf[1] = '\0';

  SendMessage(buf); //Lets server get our UDP contact info

  //Update Windows
  UpdateStats();
  UpdateClilist();
  Room << "Connected, press a key";
  //  getch();
  Room.SetName("Chat Room");
  Room.Draw();
  Room.Clear();

  return 0;
}

char* GetName() {
  char* buf = new char[32];
  Room << "Enter your name: ";
  Room.scanf(" %31[^\n]", buf);
  return buf;
}
