//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "server.h"
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>

#include <sys/socket.h> //consts and procedures
//#include <sys/types.h>
#define LinkListConflict
#include <unistd.h>     //for close()
#include <arpa/inet.h>  //for sockadd_in !!!

#include "server.h"

int NewCli(int sock) {
  //Connect to a new client
  int sin_size = sizeof(sockaddr_in);
  int newCli;
  sockaddr_in newCliAddr;
  if ((newCli = accept(sock, (sockaddr *)&newCliAddr, (size_t*)&sin_size)) == -1)
    return ERROR;
  Message << "New Connection Accepted from " << inet_ntoa(newCliAddr.sin_addr) << '\n';

  //Set non-listen socket to non-block
//  int x = 0;
//  ioctl(newCli, FIONBIO, &x);

  Message << "Retriving Client information\n";
  //Get the clients info
  gin += recv(newCli, buf, BUFLEN, 0);   //Get the packet
  uchar* buf2 = new uchar;
  Message << "Checking version\n";
  if (buf[0] == VERSION) {
    *buf2 = GOODVER;
    gout += send(newCli, buf2, 1, 0);
    Message << "  Version " << int(VERSION) << " Passed...\n";
  } else {
    *buf2 = BADVER;
    gout += send(newCli, buf2, 1, 0);
    Message << "  Version " << int(VERSION) << " Failed...\n";
    //Bad version, terminate session
    close(newCli);
    return OLDVER;
  }
  delete buf2;                         //Get rid of version temp

  //Send the client room info
  // We have to do this before adding the client to the master list because we
  // want to let the client see the server introduce inself, and at that time
  // the client will add itself to the list -- as if it was "another" user,
  // but the human user wouldn't be able to know that!
  Message << "Sending client room information\n";

  Clients.SetToStart();
  int len = Clients.Length();
  gout += send(newCli, &len, sizeof(len), 0);           //Send # of users
  for (int c=0; c<len; c++) {
    int NameLen = strlen(Clients._GetNext()->name) + 1; //Send NULL
    gout += send(newCli, &NameLen, sizeof(NameLen), 0); //Send name len
    gout += send(newCli, Clients._GetNext()->name, NameLen, 0);//Send name
    Clients._Advance();                                 //Proceed to next cli
  }

  //Setup the new client
  Clidata* NewClient = new Clidata;
  int newstrlen = strlen(&buf[1]) + 1; //Don't include version number in count
                                       // and add one for NULL
  NewClient->name = new char[newstrlen];
  strcpy(NewClient->name, &buf[1]);    //Everything else is the name

  //Ping the client
  char temp = PING;
  gout += send(newCli, &temp, sizeof(temp), 0);
  NewClient->start = clock();
  errno = 0;
  gin += recv(newCli, &temp, sizeof(temp), 0);
  NewClient->end = clock();
  NewClient->pingtime = int((NewClient->end - NewClient->start) / (CLOCKS_PER_SEC / 1000));
    //Calculate number of ms
  gout += send(newCli, &NewClient->pingtime, sizeof(NewClient->pingtime), 0);
    //Report back to client

  //Setup client for UDP access
  Message << "Moving client to UDP\n";
  newCliAddr.sin_port = htons(BPORT);  //Set to broadcasting port
  len = sizeof(NewClient->loc);
  gin += recvfrom(bsock, buf, BUFLEN, 0, (sockaddr*)&NewClient->loc, (size_t*)&len);

  Clients._MoveData(NewClient);        //Add Client to the master list

  //Announce Client
  SendNewCli(NewClient);
  sprintf(buf, "%c* %s has joined the chat!", MSG, NewClient->name);
  Broadcast(buf);
  UpdateStats();
  UpdateClilist();

  //Cleanup
  close(newCli);
  return 0; //client successfully connected
}







