//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "textbox.h"

#undef box

CTextBox::CTextBox() {
}

CTextBox::CTextBox(int x, int y, int w, int h) : box(x, y, w, h), input(NULL), maxsize(0), currpos(0) {
}

CTextBox::~CTextBox() {
  if (input)
    delete[] input;
}

void CTextBox::SetName(const char* str) {
  box.SetName(str);
}

void CTextBox::Move(int x, int y, int w, int h) {
  box.Move(x, y, w, h);
}

void CTextBox::SetColors(int back, int fore, int text) {
  box.SetColors(back, fore, text);
}

void CTextBox::Draw() {
  box.Draw();
}

void CTextBox::Erase() {
  box.Erase();
}

void CTextBox::Reset() {
  box.Clear();
  currpos = 0;
}

void CTextBox::SetMax(int max) {
  maxsize = max;
  Reset();
  if (input)
    delete[] input;

  input = new char[maxsize + 1]; //Include space for NULL
}

bool CTextBox::Update() {
  nodelay(stdscr, true);
  noecho();
  int rawch = ERR;
  if ((rawch = getch()) != ERR) {//If any input waiting
    char ch = (char)rawch;
    if (rawch == '\n') //If user pressed RETURN
      return true;
    if (rawch == 8) {//If backspaced
      currpos--;
      if (currpos < 0) {
        currpos = 0;        //Hit the end
      } else {
	box.Backspace();
      }
    } else {                //Normal character
      currpos++;
      if (currpos >= maxsize) {
        currpos = maxsize-1;//Clip off at end
      } else {
        box << ch;          //Display input
        input[currpos-1] = ch;//update input string
      }
    }
  }
  keypad(stdscr, false);
  nodelay(stdscr, false);
  return false;
}

char* CTextBox::GetInput() {
  input[currpos] = '\0';    //properly terminate string
  return input;
}
